JavaScript Data GridRow moving

Change the order of rows, either manually (dragging them to another location), or programmatically (using Handsontable's API methods).

Enable the ManualRowMove plugin

To enable row moving, set the manualRowMove option to true.

A draggable move handle appears above the selected row header. You can click and drag it to any location in the row header body.

import Handsontable from 'handsontable';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// generate an array of arrays with dummy data
const data = new Array(200) // number of rows
  .fill(null)
  .map((_, row) =>
    new Array(20) // number of columns
      .fill(null)
      .map((_, column) => `${row}, ${column}`)
  );

const container = document.querySelector('#example1');

new Handsontable(container, {
  themeName: 'ht-theme-main',
  data,
  width: '100%',
  height: 320,
  rowHeaders: true,
  colHeaders: true,
  colWidths: 100,
  manualRowMove: true,
  autoWrapRow: true,
  autoWrapCol: true,
  licenseKey: 'non-commercial-and-evaluation',
});

Drag and move actions of manualRowMove plugin

There are significant differences between the plugin's dragRows and moveRows API functions. Both of them change the order of rows, but they rely on different kinds of indexes. The differences between them are shown in the diagrams below.

Both of these methods trigger the beforeRowMove and afterRowMove hooks, but only dragRows passes the dropIndex argument to them.

The dragRows method has a dropIndex parameter, which points to where the elements are being dropped.

dragRows method

The moveRows method has a finalIndex parameter, which points to where the elements will be placed after the moving action - finalIndex being the index of the first moved element.

moveRows method

The moveRows function cannot perform some actions, e.g., more than one element can't be moved to the last position. In this scenario, the move will be cancelled. The Plugin's isMovePossible API method and the movePossible parameters beforeRowMove and afterRowMove hooks help in determine such situations.

React Data GridRow moving

Change the order of rows, either manually (dragging them to another location), or programmatically (using Handsontable's API methods).

Enable the ManualRowMove plugin

To enable row moving, set the manualRowMove option to true.

A draggable move handle appears above the selected row header. You can click and drag it to any location in the row header body.

import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

// generate an array of arrays with dummy data
const data = new Array(200) // number of rows
  .fill(0)
  .map((_, row) =>
    new Array(20) // number of columns
      .fill(0)
      .map((_, column) => `${row}, ${column}`)
  );

const ExampleComponent = () => {
  return (
    <HotTable
      themeName="ht-theme-main"
      data={data}
      width="100%"
      height={320}
      rowHeaders={true}
      colHeaders={true}
      colWidths={100}
      manualRowMove={true}
      autoWrapRow={true}
      autoWrapCol={true}
      licenseKey="non-commercial-and-evaluation"
    />
  );
};

export default ExampleComponent;

Drag and move actions of manualRowMove plugin

There are significant differences between the plugin's dragRows and moveRows API functions. Both of them change the order of rows, but they rely on different kinds of indexes. The differences between them are shown in the diagrams below.

Both of these methods trigger the beforeRowMove and afterRowMove hooks, but only dragRows passes the dropIndex argument to them.

The dragRows method has a dropIndex parameter, which points to where the elements are being dropped.

dragRows method

The moveRows method has a finalIndex parameter, which points to where the elements will be placed after the moving action - finalIndex being the index of the first moved element.

moveRows method

The moveRows function cannot perform some actions, e.g., more than one element can't be moved to the last position. In this scenario, the move will be cancelled. The Plugin's isMovePossible API method and the movePossible parameters beforeRowMove and afterRowMove hooks help in determine such situations.

Angular Data GridRow moving

Change the order of rows, either manually (dragging them to another location), or programmatically (using Handsontable's API methods).

Enable the ManualRowMove plugin

To enable row moving, set the manualRowMove option to true.

A draggable move handle appears above the selected row header. You can click and drag it to any location in the row header body.

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from "@handsontable/angular-wrapper";

@Component({
  selector: 'app-example1',
  template: `
    <hot-table
      [settings]="hotSettings!" [data]="hotData">
    </hot-table>
  `,
  standalone: false
})
export class AppComponent {

  readonly hotData = new Array(200) // number of rows
    .fill(null)
    .map((_, row) =>
      new Array(20) // number of columns
        .fill(null)
        .map((_, column) => `${row}, ${column}`)
    );

  readonly hotSettings: GridSettings = {
    width: '100%',
    height: 320,
    rowHeaders: true,
    colHeaders: true,
    colWidths: 100,
    manualRowMove: true,
    autoWrapRow: true,
    autoWrapCol: true,
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';

import { AppComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ AppComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ AppComponent ]
})

export class AppModule { }

Drag and move actions of manualRowMove plugin

There are significant differences between the plugin's dragRows and moveRows API functions. Both of them change the order of rows, but they rely on different kinds of indexes. The differences between them are shown in the diagrams below.

Both of these methods trigger the beforeRowMove and afterRowMove hooks, but only dragRows passes the dropIndex argument to them.

The dragRows method has a dropIndex parameter, which points to where the elements are being dropped.

dragRows method

The moveRows method has a finalIndex parameter, which points to where the elements will be placed after the moving action - finalIndex being the index of the first moved element.

moveRows method

The moveRows function cannot perform some actions, e.g., more than one element can't be moved to the last position. In this scenario, the move will be cancelled. The Plugin's isMovePossible API method and the movePossible parameters beforeRowMove and afterRowMove hooks help in determine such situations.

Skip to content

Change the order of rows, either manually (dragging them to another location), or programmatically (using Handsontable’s API methods).

Enable the ManualRowMove plugin

To enable row moving, set the manualRowMove option to true.

A draggable move handle appears above the selected row header. You can click and drag it to any location in the row header body.

Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
// generate an array of arrays with dummy data
const data: string[][] = new Array(200) // number of rows
.fill(null)
.map((_, row) =>
new Array(20) // number of columns
.fill(null)
.map((_, column) => `${row}, ${column}`)
);
const hotSettings = ref<GridSettings>({
data,
width: '100%',
height: 320,
rowHeaders: true,
colHeaders: true,
colWidths: 100,
manualRowMove: true,
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example1">
<HotTable :settings="hotSettings" />
</div>
</template>

Set a pre-defined row order

Instead of setting manualRowMove to true, you can pass an array of physical row indexes to define the initial visual order of rows on render.

Each position in the array corresponds to a visual (display) position, and the value at that position is the physical (source data) row index. For example:

manualRowMove: [2, 0, 1]

This renders the rows in the following order:

  • Visual position 0 → physical row 2
  • Visual position 1 → physical row 0
  • Visual position 2 → physical row 1

The array must contain all physical row indexes (its length must equal the total number of rows). After the initial render, users can still drag rows to change the order further.

API reference

dragRows vs moveRows

There are significant differences between the plugin’s dragRows and moveRows API functions. Both of them change the order of rows, but they rely on different kinds of indexes. The differences between them are shown in the diagrams below.

Both of these methods trigger the beforeRowMove and afterRowMove hooks, but only dragRows passes the dropIndex argument to them.

The dragRows method has a dropIndex parameter, which points to where the elements are being dropped.

dragRows method

The moveRows method has a finalIndex parameter, which points to where the elements will be placed after the moving action - finalIndex being the index of the first moved element.

moveRows method

The moveRows function cannot perform some actions, e.g., more than one element can’t be moved to the last position. In this scenario, the move will be cancelled. The Plugin’s isMovePossible API method and the movePossible parameters beforeRowMove and afterRowMove hooks help in determine such situations.

Configuration options

Core methods

Hooks

Plugins

Result

After completing this guide, you can reorder rows by dragging them with the mouse or by calling dragRows() and moveRows() programmatically. You can also set a pre-defined row order at initialization.